#ifndef INTERACTABLEGROUNDITEM_HPP_INCLUDED
#define INTERACTABLEGROUNDITEM_HPP_INCLUDED

#include "../../Core/Classes/GroundItem.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Convex.hpp"
#include <cstdint>

namespace Interactable
{
    class GroundItem : public Internal::GroundItem
    {
        private:
            std::int32_t X;
            std::int32_t Y;
        public:
            GroundItem(const Internal::GroundItem& G);
            GroundItem(const Internal::GroundItem& G, std::int32_t X, std::int32_t Y);
            GroundItem(const GroundItem& G);

            std::int32_t GetID() const;
            std::string GetName() const;
            Tile GetTile() const;
            Internal::ObjectInfo GetInfo() const;
            std::vector<Point> GetModel() const;
            Convex GetConvex() const;

            operator Internal::GroundItem() const;
    };
}


#endif // INTERACTABLEGROUNDITEM_HPP_INCLUDED
